﻿/*
  Copyrights 2005-2010 Sisulizer

  A class that translates windows and pages of a WPF application.
 
  Note! This is currently on alpha an does not work on every applications.
*/

using System;
using System.Reflection;
using System.Globalization;
using System.Threading;
using System.Windows;

namespace Sisulizer.WPF
{
  public class Translator
  {
    Assembly assembly;

    public Translator(Assembly assembly)
    {
      this.assembly = assembly;

      foreach (Window window in Application.Current.Windows)
        TranslateWindow(window);
    }

    public Translator(Assembly assembly, Window window)
    {
      this.assembly = assembly;
      TranslateWindow(window);
    }

    private void TranslateWindow(Window window)
    {
      System.Windows.Application.LoadComponent(
        window,
        new System.Uri(
          String.Format("/{0};component/{1}.xaml", assembly.FullName, window.GetType().Name),
          System.UriKind.Relative));
    }

    // Translate all windows
    static public void Translate(Assembly assembly)
    {
      new Translator(assembly);
    }

    // Translate only the given window
    static public void Translate(Assembly assembly, Window window)
    {
      new Translator(assembly, window);
    }

    // Set a new UI language and translate all existing forms.
    static public void SetUILanguage(CultureInfo language, Assembly assembly)
    {
      Thread.CurrentThread.CurrentUICulture = language;
      Translator.Translate(assembly);
    }
  }
}
