﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;
using System.Globalization;

namespace CommandLine
{
  static class Program
  {
    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main(string[] args)
    {
      // If a command line parameter is passed then turn that language on. However if the parameter
      // is xx then turn on the language specified in Control Panel's Regional settings.
      if (args.Length > 0)
      {
        string lang = args[0];

        if (lang == "xx")
          Thread.CurrentThread.CurrentUICulture = CultureInfo.CurrentCulture;
        else
          Thread.CurrentThread.CurrentUICulture = new CultureInfo(args[0]);
      }
      
      Application.EnableVisualStyles();
      Application.SetCompatibleTextRenderingDefault(false);
      Application.Run(new Form1());
    }
  }
}
