/*
  Copyrights 2005-2011 Sisulizer
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using Sisulizer;
using Sisulizer.WindowsForms;

namespace LangChange
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void SetDynamicProperties()
    {
      // This function sets the values of dynamic properties. This means the properties
      // that value is not stored in the .resx of the form but it set on run time
      label1.Text = Properties.Resources.String1;
    }

    private void language_Click(object sender, EventArgs e)
    {
      // Set the new UI language. 
      // This translates static properties (e.g. those in .resx) automatically.
      Translator.SetUILanguage((sender as RadioButton).Tag as CultureInfo);

      // Translate dynamic properties
      SetDynamicProperties();
    }

    private void AddLanguage(CultureInfo cultureInfo)
    {
      RadioButton radioButton = new RadioButton();
      radioButton.Parent = groupBox1;
      radioButton.Text = cultureInfo.NativeName;
      radioButton.Top = 16 + (groupBox1.Controls.Count - 1)*radioButton.Height;
      radioButton.Left = 8;
      radioButton.Checked = cultureInfo.TwoLetterISOLanguageName == Thread.CurrentThread.CurrentUICulture.TwoLetterISOLanguageName;
      radioButton.Tag = cultureInfo;
      radioButton.Click += new System.EventHandler(language_Click);
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      // Populate language group. 
      // Add English and all the languages that has satellite assembly file
      CultureInfo[] languages = Resources.GetAvailableLanguages();

      AddLanguage(new CultureInfo("en"));

      for (int i = 0; i < languages.Length; i++)
        AddLanguage(languages[i]);
 
      // Set the dynamic properties
      SetDynamicProperties();
    }
  }
}