unit WinForm;

interface

uses
  System.Drawing,
  System.Collections,
  System.ComponentModel,
  System.Windows.Forms,
  System.Data,
  System.Resources,
  LaCommon;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    MainMenu: System.Windows.Forms.MainMenu;
    FileMenuItem: System.Windows.Forms.MenuItem;
    ExitMenuItem: System.Windows.Forms.MenuItem;
    HelpMenuItem: System.Windows.Forms.MenuItem;
    AboutMenuItem: System.Windows.Forms.MenuItem;
    TypeLabel: System.Windows.Forms.Label;
    TypeCombo: System.Windows.Forms.ComboBox;
    MetricUnitLabel: System.Windows.Forms.Label;
    MetricCombo: System.Windows.Forms.ComboBox;
    MetricAmountLabel: System.Windows.Forms.Label;
    MetricText: System.Windows.Forms.TextBox;
    UsUnitLabel: System.Windows.Forms.Label;
    Label5: System.Windows.Forms.Label;
    UsCombo: System.Windows.Forms.ComboBox;
    UsText: System.Windows.Forms.TextBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure TWinForm_Load(sender: System.Object; e: System.EventArgs);
    procedure MetricText_TextChanged(sender: System.Object; e: System.EventArgs);
    procedure TypeCombo_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure UsText_TextChanged(sender: System.Object; e: System.EventArgs);
    procedure ExitMenuItem_Click(sender: System.Object; e: System.EventArgs);
    procedure AboutMenuItem_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;

  private
    FUpdating: Boolean;
    FRm: ResourceManager;

    function GetQuantity: TQuantity;
    function GetMetricLength: TLaMetricLength;
    function GetUsLength: TLaUsLength;
    function GetMetricTemperature: TLaMetricTemperature;
    function GetUsTemperature: TLaUsTemperature;

    function GetMetricValue: System.Double;
    procedure SetMetricValue(Value: System.Double);

    function GetUsValue: System.Double;
    procedure SetUsValue(Value: System.Double);

    procedure AddMetric(value: String);
    procedure AddUs(value: String);

  public
    constructor Create;

    property Quantity: TQuantity read GetQuantity;
    property MetricLength: TLaMetricLength read GetMetricLength;
    property UsLength: TLaUsLength read GetUsLength;
    property MetricTemperature: TLaMetricTemperature read GetMetricTemperature;
    property UsTemperature: TLaUsTemperature read GetUsTemperature;
    property MetricValue: System.Double read GetMetricValue write SetMetricValue;
    property UsValue: System.Double read GetUsValue write SetUsValue;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

uses
  System.Threading,
  System.Globalization;

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
type
  TArrayOfSystem_Windows_Forms_MenuItem = array of System.Windows.Forms.MenuItem;
var
  resources: System.Resources.ResourceManager;
begin
  resources := System.Resources.ResourceManager.Create(TypeOf(TWinForm));
  Self.MainMenu := System.Windows.Forms.MainMenu.Create;
  Self.FileMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.ExitMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.HelpMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.AboutMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.TypeLabel := System.Windows.Forms.Label.Create;
  Self.TypeCombo := System.Windows.Forms.ComboBox.Create;
  Self.MetricUnitLabel := System.Windows.Forms.Label.Create;
  Self.MetricCombo := System.Windows.Forms.ComboBox.Create;
  Self.MetricAmountLabel := System.Windows.Forms.Label.Create;
  Self.MetricText := System.Windows.Forms.TextBox.Create;
  Self.UsUnitLabel := System.Windows.Forms.Label.Create;
  Self.Label5 := System.Windows.Forms.Label.Create;
  Self.UsCombo := System.Windows.Forms.ComboBox.Create;
  Self.UsText := System.Windows.Forms.TextBox.Create;
  Self.SuspendLayout;
  // 
  // MainMenu
  // 
  Self.MainMenu.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.FileMenuItem, 
          Self.HelpMenuItem));
  Self.MainMenu.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('M' +
    'ainMenu.RightToLeft')));
  // 
  // FileMenuItem
  // 
  Self.FileMenuItem.Enabled := (Boolean(resources.GetObject('FileMenuItem.En' +
    'abled')));
  Self.FileMenuItem.Index := 0;
  Self.FileMenuItem.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.ExitMenuItem));
  Self.FileMenuItem.Shortcut := (System.Windows.Forms.Shortcut(resources.GetObject('F' +
    'ileMenuItem.Shortcut')));
  Self.FileMenuItem.ShowShortcut := (Boolean(resources.GetObject('FileMenuIt' +
    'em.ShowShortcut')));
  Self.FileMenuItem.Text := resources.GetString('FileMenuItem.Text');
  Self.FileMenuItem.Visible := (Boolean(resources.GetObject('FileMenuItem.Vi' +
    'sible')));
  // 
  // ExitMenuItem
  // 
  Self.ExitMenuItem.Enabled := (Boolean(resources.GetObject('ExitMenuItem.En' +
    'abled')));
  Self.ExitMenuItem.Index := 0;
  Self.ExitMenuItem.Shortcut := (System.Windows.Forms.Shortcut(resources.GetObject('E' +
    'xitMenuItem.Shortcut')));
  Self.ExitMenuItem.ShowShortcut := (Boolean(resources.GetObject('ExitMenuIt' +
    'em.ShowShortcut')));
  Self.ExitMenuItem.Text := resources.GetString('ExitMenuItem.Text');
  Self.ExitMenuItem.Visible := (Boolean(resources.GetObject('ExitMenuItem.Vi' +
    'sible')));
  Include(Self.ExitMenuItem.Click, Self.ExitMenuItem_Click);
  // 
  // HelpMenuItem
  // 
  Self.HelpMenuItem.Enabled := (Boolean(resources.GetObject('HelpMenuItem.En' +
    'abled')));
  Self.HelpMenuItem.Index := 1;
  Self.HelpMenuItem.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.AboutMenuItem));
  Self.HelpMenuItem.Shortcut := (System.Windows.Forms.Shortcut(resources.GetObject('H' +
    'elpMenuItem.Shortcut')));
  Self.HelpMenuItem.ShowShortcut := (Boolean(resources.GetObject('HelpMenuIt' +
    'em.ShowShortcut')));
  Self.HelpMenuItem.Text := resources.GetString('HelpMenuItem.Text');
  Self.HelpMenuItem.Visible := (Boolean(resources.GetObject('HelpMenuItem.Vi' +
    'sible')));
  // 
  // AboutMenuItem
  // 
  Self.AboutMenuItem.Enabled := (Boolean(resources.GetObject('AboutMenuItem.' +
    'Enabled')));
  Self.AboutMenuItem.Index := 0;
  Self.AboutMenuItem.Shortcut := (System.Windows.Forms.Shortcut(resources.GetObject('A' +
    'boutMenuItem.Shortcut')));
  Self.AboutMenuItem.ShowShortcut := (Boolean(resources.GetObject('AboutMenu' +
    'Item.ShowShortcut')));
  Self.AboutMenuItem.Text := resources.GetString('AboutMenuItem.Text');
  Self.AboutMenuItem.Visible := (Boolean(resources.GetObject('AboutMenuItem.' +
    'Visible')));
  Include(Self.AboutMenuItem.Click, Self.AboutMenuItem_Click);
  // 
  // TypeLabel
  // 
  Self.TypeLabel.AccessibleDescription := resources.GetString('TypeLabel.Acc' +
    'essibleDescription');
  Self.TypeLabel.AccessibleName := resources.GetString('TypeLabel.Accessible' +
    'Name');
  Self.TypeLabel.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('T' +
    'ypeLabel.Anchor')));
  Self.TypeLabel.AutoSize := (Boolean(resources.GetObject('TypeLabel.AutoSiz' +
    'e')));
  Self.TypeLabel.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('T' +
    'ypeLabel.Dock')));
  Self.TypeLabel.Enabled := (Boolean(resources.GetObject('TypeLabel.Enabled')));
  Self.TypeLabel.Font := (System.Drawing.Font(resources.GetObject('TypeLabel' +
    '.Font')));
  Self.TypeLabel.Image := (System.Drawing.Image(resources.GetObject('TypeLab' +
    'el.Image')));
  Self.TypeLabel.ImageAlign := (System.Drawing.ContentAlignment(resources.GetObject('T' +
    'ypeLabel.ImageAlign')));
  Self.TypeLabel.ImageIndex := (Integer(resources.GetObject('TypeLabel.Image' +
    'Index')));
  Self.TypeLabel.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('T' +
    'ypeLabel.ImeMode')));
  Self.TypeLabel.Location := (System.Drawing.Point(resources.GetObject('Type' +
    'Label.Location')));
  Self.TypeLabel.Name := 'TypeLabel';
  Self.TypeLabel.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('T' +
    'ypeLabel.RightToLeft')));
  Self.TypeLabel.Size := (System.Drawing.Size(resources.GetObject('TypeLabel' +
    '.Size')));
  Self.TypeLabel.TabIndex := (Integer(resources.GetObject('TypeLabel.TabInde' +
    'x')));
  Self.TypeLabel.Text := resources.GetString('TypeLabel.Text');
  Self.TypeLabel.TextAlign := (System.Drawing.ContentAlignment(resources.GetObject('T' +
    'ypeLabel.TextAlign')));
  Self.TypeLabel.Visible := (Boolean(resources.GetObject('TypeLabel.Visible')));
  // 
  // TypeCombo
  // 
  Self.TypeCombo.AccessibleDescription := resources.GetString('TypeCombo.Acc' +
    'essibleDescription');
  Self.TypeCombo.AccessibleName := resources.GetString('TypeCombo.Accessible' +
    'Name');
  Self.TypeCombo.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('T' +
    'ypeCombo.Anchor')));
  Self.TypeCombo.BackgroundImage := (System.Drawing.Image(resources.GetObject('T' +
    'ypeCombo.BackgroundImage')));
  Self.TypeCombo.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('T' +
    'ypeCombo.Dock')));
  Self.TypeCombo.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.TypeCombo.Enabled := (Boolean(resources.GetObject('TypeCombo.Enabled')));
  Self.TypeCombo.Font := (System.Drawing.Font(resources.GetObject('TypeCombo' +
    '.Font')));
  Self.TypeCombo.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('T' +
    'ypeCombo.ImeMode')));
  Self.TypeCombo.IntegralHeight := (Boolean(resources.GetObject('TypeCombo.I' +
    'ntegralHeight')));
  Self.TypeCombo.ItemHeight := (Integer(resources.GetObject('TypeCombo.ItemH' +
    'eight')));
  Self.TypeCombo.Location := (System.Drawing.Point(resources.GetObject('Type' +
    'Combo.Location')));
  Self.TypeCombo.MaxDropDownItems := (Integer(resources.GetObject('TypeCombo' +
    '.MaxDropDownItems')));
  Self.TypeCombo.MaxLength := (Integer(resources.GetObject('TypeCombo.MaxLen' +
    'gth')));
  Self.TypeCombo.Name := 'TypeCombo';
  Self.TypeCombo.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('T' +
    'ypeCombo.RightToLeft')));
  Self.TypeCombo.Size := (System.Drawing.Size(resources.GetObject('TypeCombo' +
    '.Size')));
  Self.TypeCombo.TabIndex := (Integer(resources.GetObject('TypeCombo.TabInde' +
    'x')));
  Self.TypeCombo.Text := resources.GetString('TypeCombo.Text');
  Self.TypeCombo.Visible := (Boolean(resources.GetObject('TypeCombo.Visible')));
  Include(Self.TypeCombo.SelectedIndexChanged, Self.TypeCombo_SelectedIndexChanged);
  // 
  // MetricUnitLabel
  // 
  Self.MetricUnitLabel.AccessibleDescription := resources.GetString('MetricU' +
    'nitLabel.AccessibleDescription');
  Self.MetricUnitLabel.AccessibleName := resources.GetString('MetricUnitLabe' +
    'l.AccessibleName');
  Self.MetricUnitLabel.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('M' +
    'etricUnitLabel.Anchor')));
  Self.MetricUnitLabel.AutoSize := (Boolean(resources.GetObject('MetricUnitL' +
    'abel.AutoSize')));
  Self.MetricUnitLabel.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('M' +
    'etricUnitLabel.Dock')));
  Self.MetricUnitLabel.Enabled := (Boolean(resources.GetObject('MetricUnitLa' +
    'bel.Enabled')));
  Self.MetricUnitLabel.Font := (System.Drawing.Font(resources.GetObject('Met' +
    'ricUnitLabel.Font')));
  Self.MetricUnitLabel.Image := (System.Drawing.Image(resources.GetObject('M' +
    'etricUnitLabel.Image')));
  Self.MetricUnitLabel.ImageAlign := (System.Drawing.ContentAlignment(resources.GetObject('M' +
    'etricUnitLabel.ImageAlign')));
  Self.MetricUnitLabel.ImageIndex := (Integer(resources.GetObject('MetricUni' +
    'tLabel.ImageIndex')));
  Self.MetricUnitLabel.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('M' +
    'etricUnitLabel.ImeMode')));
  Self.MetricUnitLabel.Location := (System.Drawing.Point(resources.GetObject('M' +
    'etricUnitLabel.Location')));
  Self.MetricUnitLabel.Name := 'MetricUnitLabel';
  Self.MetricUnitLabel.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('M' +
    'etricUnitLabel.RightToLeft')));
  Self.MetricUnitLabel.Size := (System.Drawing.Size(resources.GetObject('Met' +
    'ricUnitLabel.Size')));
  Self.MetricUnitLabel.TabIndex := (Integer(resources.GetObject('MetricUnitL' +
    'abel.TabIndex')));
  Self.MetricUnitLabel.Text := resources.GetString('MetricUnitLabel.Text');
  Self.MetricUnitLabel.TextAlign := (System.Drawing.ContentAlignment(resources.GetObject('M' +
    'etricUnitLabel.TextAlign')));
  Self.MetricUnitLabel.Visible := (Boolean(resources.GetObject('MetricUnitLa' +
    'bel.Visible')));
  // 
  // MetricCombo
  // 
  Self.MetricCombo.AccessibleDescription := resources.GetString('MetricCombo' +
    '.AccessibleDescription');
  Self.MetricCombo.AccessibleName := resources.GetString('MetricCombo.Access' +
    'ibleName');
  Self.MetricCombo.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('M' +
    'etricCombo.Anchor')));
  Self.MetricCombo.BackgroundImage := (System.Drawing.Image(resources.GetObject('M' +
    'etricCombo.BackgroundImage')));
  Self.MetricCombo.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('M' +
    'etricCombo.Dock')));
  Self.MetricCombo.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.MetricCombo.Enabled := (Boolean(resources.GetObject('MetricCombo.Enab' +
    'led')));
  Self.MetricCombo.Font := (System.Drawing.Font(resources.GetObject('MetricC' +
    'ombo.Font')));
  Self.MetricCombo.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('M' +
    'etricCombo.ImeMode')));
  Self.MetricCombo.IntegralHeight := (Boolean(resources.GetObject('MetricCom' +
    'bo.IntegralHeight')));
  Self.MetricCombo.ItemHeight := (Integer(resources.GetObject('MetricCombo.I' +
    'temHeight')));
  Self.MetricCombo.Location := (System.Drawing.Point(resources.GetObject('Me' +
    'tricCombo.Location')));
  Self.MetricCombo.MaxDropDownItems := (Integer(resources.GetObject('MetricC' +
    'ombo.MaxDropDownItems')));
  Self.MetricCombo.MaxLength := (Integer(resources.GetObject('MetricCombo.Ma' +
    'xLength')));
  Self.MetricCombo.Name := 'MetricCombo';
  Self.MetricCombo.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('M' +
    'etricCombo.RightToLeft')));
  Self.MetricCombo.Size := (System.Drawing.Size(resources.GetObject('MetricC' +
    'ombo.Size')));
  Self.MetricCombo.TabIndex := (Integer(resources.GetObject('MetricCombo.Tab' +
    'Index')));
  Self.MetricCombo.Text := resources.GetString('MetricCombo.Text');
  Self.MetricCombo.Visible := (Boolean(resources.GetObject('MetricCombo.Visi' +
    'ble')));
  // 
  // MetricAmountLabel
  // 
  Self.MetricAmountLabel.AccessibleDescription := resources.GetString('Metri' +
    'cAmountLabel.AccessibleDescription');
  Self.MetricAmountLabel.AccessibleName := resources.GetString('MetricAmount' +
    'Label.AccessibleName');
  Self.MetricAmountLabel.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('M' +
    'etricAmountLabel.Anchor')));
  Self.MetricAmountLabel.AutoSize := (Boolean(resources.GetObject('MetricAmo' +
    'untLabel.AutoSize')));
  Self.MetricAmountLabel.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('M' +
    'etricAmountLabel.Dock')));
  Self.MetricAmountLabel.Enabled := (Boolean(resources.GetObject('MetricAmou' +
    'ntLabel.Enabled')));
  Self.MetricAmountLabel.Font := (System.Drawing.Font(resources.GetObject('M' +
    'etricAmountLabel.Font')));
  Self.MetricAmountLabel.Image := (System.Drawing.Image(resources.GetObject('M' +
    'etricAmountLabel.Image')));
  Self.MetricAmountLabel.ImageAlign := (System.Drawing.ContentAlignment(resources.GetObject('M' +
    'etricAmountLabel.ImageAlign')));
  Self.MetricAmountLabel.ImageIndex := (Integer(resources.GetObject('MetricA' +
    'mountLabel.ImageIndex')));
  Self.MetricAmountLabel.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('M' +
    'etricAmountLabel.ImeMode')));
  Self.MetricAmountLabel.Location := (System.Drawing.Point(resources.GetObject('M' +
    'etricAmountLabel.Location')));
  Self.MetricAmountLabel.Name := 'MetricAmountLabel';
  Self.MetricAmountLabel.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('M' +
    'etricAmountLabel.RightToLeft')));
  Self.MetricAmountLabel.Size := (System.Drawing.Size(resources.GetObject('M' +
    'etricAmountLabel.Size')));
  Self.MetricAmountLabel.TabIndex := (Integer(resources.GetObject('MetricAmo' +
    'untLabel.TabIndex')));
  Self.MetricAmountLabel.Text := resources.GetString('MetricAmountLabel.Text');
  Self.MetricAmountLabel.TextAlign := (System.Drawing.ContentAlignment(resources.GetObject('M' +
    'etricAmountLabel.TextAlign')));
  Self.MetricAmountLabel.Visible := (Boolean(resources.GetObject('MetricAmou' +
    'ntLabel.Visible')));
  // 
  // MetricText
  // 
  Self.MetricText.AccessibleDescription := resources.GetString('MetricText.A' +
    'ccessibleDescription');
  Self.MetricText.AccessibleName := resources.GetString('MetricText.Accessib' +
    'leName');
  Self.MetricText.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('M' +
    'etricText.Anchor')));
  Self.MetricText.AutoSize := (Boolean(resources.GetObject('MetricText.AutoS' +
    'ize')));
  Self.MetricText.BackgroundImage := (System.Drawing.Image(resources.GetObject('M' +
    'etricText.BackgroundImage')));
  Self.MetricText.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('M' +
    'etricText.Dock')));
  Self.MetricText.Enabled := (Boolean(resources.GetObject('MetricText.Enable' +
    'd')));
  Self.MetricText.Font := (System.Drawing.Font(resources.GetObject('MetricTe' +
    'xt.Font')));
  Self.MetricText.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('M' +
    'etricText.ImeMode')));
  Self.MetricText.Location := (System.Drawing.Point(resources.GetObject('Met' +
    'ricText.Location')));
  Self.MetricText.MaxLength := (Integer(resources.GetObject('MetricText.MaxL' +
    'ength')));
  Self.MetricText.Multiline := (Boolean(resources.GetObject('MetricText.Mult' +
    'iline')));
  Self.MetricText.Name := 'MetricText';
  Self.MetricText.PasswordChar := (WideChar(resources.GetObject('MetricText.' +
    'PasswordChar')));
  Self.MetricText.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('M' +
    'etricText.RightToLeft')));
  Self.MetricText.ScrollBars := (System.Windows.Forms.ScrollBars(resources.GetObject('M' +
    'etricText.ScrollBars')));
  Self.MetricText.Size := (System.Drawing.Size(resources.GetObject('MetricTe' +
    'xt.Size')));
  Self.MetricText.TabIndex := (Integer(resources.GetObject('MetricText.TabIn' +
    'dex')));
  Self.MetricText.Text := resources.GetString('MetricText.Text');
  Self.MetricText.TextAlign := (System.Windows.Forms.HorizontalAlignment(resources.GetObject('M' +
    'etricText.TextAlign')));
  Self.MetricText.Visible := (Boolean(resources.GetObject('MetricText.Visibl' +
    'e')));
  Self.MetricText.WordWrap := (Boolean(resources.GetObject('MetricText.WordW' +
    'rap')));
  Include(Self.MetricText.TextChanged, Self.MetricText_TextChanged);
  // 
  // UsUnitLabel
  // 
  Self.UsUnitLabel.AccessibleDescription := resources.GetString('UsUnitLabel' +
    '.AccessibleDescription');
  Self.UsUnitLabel.AccessibleName := resources.GetString('UsUnitLabel.Access' +
    'ibleName');
  Self.UsUnitLabel.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('U' +
    'sUnitLabel.Anchor')));
  Self.UsUnitLabel.AutoSize := (Boolean(resources.GetObject('UsUnitLabel.Aut' +
    'oSize')));
  Self.UsUnitLabel.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('U' +
    'sUnitLabel.Dock')));
  Self.UsUnitLabel.Enabled := (Boolean(resources.GetObject('UsUnitLabel.Enab' +
    'led')));
  Self.UsUnitLabel.Font := (System.Drawing.Font(resources.GetObject('UsUnitL' +
    'abel.Font')));
  Self.UsUnitLabel.Image := (System.Drawing.Image(resources.GetObject('UsUni' +
    'tLabel.Image')));
  Self.UsUnitLabel.ImageAlign := (System.Drawing.ContentAlignment(resources.GetObject('U' +
    'sUnitLabel.ImageAlign')));
  Self.UsUnitLabel.ImageIndex := (Integer(resources.GetObject('UsUnitLabel.I' +
    'mageIndex')));
  Self.UsUnitLabel.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('U' +
    'sUnitLabel.ImeMode')));
  Self.UsUnitLabel.Location := (System.Drawing.Point(resources.GetObject('Us' +
    'UnitLabel.Location')));
  Self.UsUnitLabel.Name := 'UsUnitLabel';
  Self.UsUnitLabel.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('U' +
    'sUnitLabel.RightToLeft')));
  Self.UsUnitLabel.Size := (System.Drawing.Size(resources.GetObject('UsUnitL' +
    'abel.Size')));
  Self.UsUnitLabel.TabIndex := (Integer(resources.GetObject('UsUnitLabel.Tab' +
    'Index')));
  Self.UsUnitLabel.Text := resources.GetString('UsUnitLabel.Text');
  Self.UsUnitLabel.TextAlign := (System.Drawing.ContentAlignment(resources.GetObject('U' +
    'sUnitLabel.TextAlign')));
  Self.UsUnitLabel.Visible := (Boolean(resources.GetObject('UsUnitLabel.Visi' +
    'ble')));
  // 
  // Label5
  // 
  Self.Label5.AccessibleDescription := resources.GetString('Label5.Accessibl' +
    'eDescription');
  Self.Label5.AccessibleName := resources.GetString('Label5.AccessibleName');
  Self.Label5.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('L' +
    'abel5.Anchor')));
  Self.Label5.AutoSize := (Boolean(resources.GetObject('Label5.AutoSize')));
  Self.Label5.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('L' +
    'abel5.Dock')));
  Self.Label5.Enabled := (Boolean(resources.GetObject('Label5.Enabled')));
  Self.Label5.Font := (System.Drawing.Font(resources.GetObject('Label5.Font')));
  Self.Label5.Image := (System.Drawing.Image(resources.GetObject('Label5.Ima' +
    'ge')));
  Self.Label5.ImageAlign := (System.Drawing.ContentAlignment(resources.GetObject('L' +
    'abel5.ImageAlign')));
  Self.Label5.ImageIndex := (Integer(resources.GetObject('Label5.ImageIndex')));
  Self.Label5.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('L' +
    'abel5.ImeMode')));
  Self.Label5.Location := (System.Drawing.Point(resources.GetObject('Label5.' +
    'Location')));
  Self.Label5.Name := 'Label5';
  Self.Label5.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('L' +
    'abel5.RightToLeft')));
  Self.Label5.Size := (System.Drawing.Size(resources.GetObject('Label5.Size')));
  Self.Label5.TabIndex := (Integer(resources.GetObject('Label5.TabIndex')));
  Self.Label5.Text := resources.GetString('Label5.Text');
  Self.Label5.TextAlign := (System.Drawing.ContentAlignment(resources.GetObject('L' +
    'abel5.TextAlign')));
  Self.Label5.Visible := (Boolean(resources.GetObject('Label5.Visible')));
  // 
  // UsCombo
  // 
  Self.UsCombo.AccessibleDescription := resources.GetString('UsCombo.Accessi' +
    'bleDescription');
  Self.UsCombo.AccessibleName := resources.GetString('UsCombo.AccessibleName');
  Self.UsCombo.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('U' +
    'sCombo.Anchor')));
  Self.UsCombo.BackgroundImage := (System.Drawing.Image(resources.GetObject('U' +
    'sCombo.BackgroundImage')));
  Self.UsCombo.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('U' +
    'sCombo.Dock')));
  Self.UsCombo.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.UsCombo.Enabled := (Boolean(resources.GetObject('UsCombo.Enabled')));
  Self.UsCombo.Font := (System.Drawing.Font(resources.GetObject('UsCombo.Fon' +
    't')));
  Self.UsCombo.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('U' +
    'sCombo.ImeMode')));
  Self.UsCombo.IntegralHeight := (Boolean(resources.GetObject('UsCombo.Integ' +
    'ralHeight')));
  Self.UsCombo.ItemHeight := (Integer(resources.GetObject('UsCombo.ItemHeigh' +
    't')));
  Self.UsCombo.Location := (System.Drawing.Point(resources.GetObject('UsComb' +
    'o.Location')));
  Self.UsCombo.MaxDropDownItems := (Integer(resources.GetObject('UsCombo.Max' +
    'DropDownItems')));
  Self.UsCombo.MaxLength := (Integer(resources.GetObject('UsCombo.MaxLength')));
  Self.UsCombo.Name := 'UsCombo';
  Self.UsCombo.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('U' +
    'sCombo.RightToLeft')));
  Self.UsCombo.Size := (System.Drawing.Size(resources.GetObject('UsCombo.Siz' +
    'e')));
  Self.UsCombo.TabIndex := (Integer(resources.GetObject('UsCombo.TabIndex')));
  Self.UsCombo.Text := resources.GetString('UsCombo.Text');
  Self.UsCombo.Visible := (Boolean(resources.GetObject('UsCombo.Visible')));
  // 
  // UsText
  // 
  Self.UsText.AccessibleDescription := resources.GetString('UsText.Accessibl' +
    'eDescription');
  Self.UsText.AccessibleName := resources.GetString('UsText.AccessibleName');
  Self.UsText.Anchor := (System.Windows.Forms.AnchorStyles(resources.GetObject('U' +
    'sText.Anchor')));
  Self.UsText.AutoSize := (Boolean(resources.GetObject('UsText.AutoSize')));
  Self.UsText.BackgroundImage := (System.Drawing.Image(resources.GetObject('U' +
    'sText.BackgroundImage')));
  Self.UsText.Dock := (System.Windows.Forms.DockStyle(resources.GetObject('U' +
    'sText.Dock')));
  Self.UsText.Enabled := (Boolean(resources.GetObject('UsText.Enabled')));
  Self.UsText.Font := (System.Drawing.Font(resources.GetObject('UsText.Font')));
  Self.UsText.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('U' +
    'sText.ImeMode')));
  Self.UsText.Location := (System.Drawing.Point(resources.GetObject('UsText.' +
    'Location')));
  Self.UsText.MaxLength := (Integer(resources.GetObject('UsText.MaxLength')));
  Self.UsText.Multiline := (Boolean(resources.GetObject('UsText.Multiline')));
  Self.UsText.Name := 'UsText';
  Self.UsText.PasswordChar := (WideChar(resources.GetObject('UsText.Password' +
    'Char')));
  Self.UsText.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('U' +
    'sText.RightToLeft')));
  Self.UsText.ScrollBars := (System.Windows.Forms.ScrollBars(resources.GetObject('U' +
    'sText.ScrollBars')));
  Self.UsText.Size := (System.Drawing.Size(resources.GetObject('UsText.Size')));
  Self.UsText.TabIndex := (Integer(resources.GetObject('UsText.TabIndex')));
  Self.UsText.Text := resources.GetString('UsText.Text');
  Self.UsText.TextAlign := (System.Windows.Forms.HorizontalAlignment(resources.GetObject('U' +
    'sText.TextAlign')));
  Self.UsText.Visible := (Boolean(resources.GetObject('UsText.Visible')));
  Self.UsText.WordWrap := (Boolean(resources.GetObject('UsText.WordWrap')));
  Include(Self.UsText.TextChanged, Self.UsText_TextChanged);
  // 
  // TWinForm
  // 
  Self.AccessibleDescription := resources.GetString('$this.AccessibleDescrip' +
    'tion');
  Self.AccessibleName := resources.GetString('$this.AccessibleName');
  Self.AutoScaleBaseSize := (System.Drawing.Size(resources.GetObject('$this.' +
    'AutoScaleBaseSize')));
  Self.AutoScroll := (Boolean(resources.GetObject('$this.AutoScroll')));
  Self.AutoScrollMargin := (System.Drawing.Size(resources.GetObject('$this.A' +
    'utoScrollMargin')));
  Self.AutoScrollMinSize := (System.Drawing.Size(resources.GetObject('$this.' +
    'AutoScrollMinSize')));
  Self.BackgroundImage := (System.Drawing.Image(resources.GetObject('$this.B' +
    'ackgroundImage')));
  Self.ClientSize := (System.Drawing.Size(resources.GetObject('$this.ClientS' +
    'ize')));
  Self.Controls.Add(Self.UsText);
  Self.Controls.Add(Self.Label5);
  Self.Controls.Add(Self.UsUnitLabel);
  Self.Controls.Add(Self.MetricText);
  Self.Controls.Add(Self.MetricAmountLabel);
  Self.Controls.Add(Self.MetricUnitLabel);
  Self.Controls.Add(Self.TypeLabel);
  Self.Controls.Add(Self.UsCombo);
  Self.Controls.Add(Self.MetricCombo);
  Self.Controls.Add(Self.TypeCombo);
  Self.Enabled := (Boolean(resources.GetObject('$this.Enabled')));
  Self.Font := (System.Drawing.Font(resources.GetObject('$this.Font')));
  Self.Icon := (System.Drawing.Icon(resources.GetObject('$this.Icon')));
  Self.ImeMode := (System.Windows.Forms.ImeMode(resources.GetObject('$this.I' +
    'meMode')));
  Self.Location := (System.Drawing.Point(resources.GetObject('$this.Location')));
  Self.MaximumSize := (System.Drawing.Size(resources.GetObject('$this.Maximu' +
    'mSize')));
  Self.Menu := Self.MainMenu;
  Self.MinimumSize := (System.Drawing.Size(resources.GetObject('$this.Minimu' +
    'mSize')));
  Self.Name := 'TWinForm';
  Self.RightToLeft := (System.Windows.Forms.RightToLeft(resources.GetObject('$' +
    'this.RightToLeft')));
  Self.StartPosition := (System.Windows.Forms.FormStartPosition(resources.GetObject('$' +
    'this.StartPosition')));
  Self.Text := resources.GetString('$this.Text');
  Include(Self.Load, Self.TWinForm_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  InitializeComponent;
end;

function TWinForm.GetQuantity: TQuantity;
begin
  Result := TQuantity(TypeCombo.SelectedIndex);
end;

function TWinForm.GetMetricLength: TLaMetricLength;
begin
  Result := TLaMetricLength(MetricCombo.SelectedIndex);
end;

function TWinForm.GetUsLength: TLaUsLength;
begin
  Result := TLaUsLength(UsCombo.SelectedIndex);
end;

function TWinForm.GetMetricTemperature: TLaMetricTemperature;
begin
  Result := TLaMetricTemperature(MetricCombo.SelectedIndex);
end;

function TWinForm.GetUsTemperature: TLaUsTemperature;
begin
  Result := TLaUsTemperature(UsCombo.SelectedIndex);
end;

function TWinForm.GetMetricValue: System.Double;
begin
  try
    Result := Convert.ToDouble(MetricText.Text);
  except
    Result := 0;
  end;
end;

procedure TWinForm.SetMetricValue(Value: System.Double);
begin
  try
    FUpdating := True;
    MetricText.Text := value.ToString('F');
  finally
    FUpdating := False;
  end;
end;

function TWinForm.GetUsValue: System.Double;
begin
  try
    Result := Convert.ToDouble(UsText.Text);
  except
    Result := 0;
  end;
end;

procedure TWinForm.SetUsValue(Value: System.Double);
begin
  try
    FUpdating := True;
    UsText.Text := value.ToString('F');
  finally
    FUpdating := False;
  end;
end;

procedure TWinForm.AddMetric(value: String);
begin
  MetricCombo.Items.Add(FRm.GetString(value));
end;

procedure TWinForm.AddUs(value: String);
begin
  UsCombo.Items.Add(FRm.GetString(value));
end;

procedure TWinForm.TWinForm_Load(sender: System.Object; e: System.EventArgs);
begin
  FRm := ResourceManager.Create('Resource', GetType().Assembly);

  TypeCombo.Items.Add(FRm.GetString('Length'));
  TypeCombo.Items.Add(FRm.GetString('Temperature'));
  TypeCombo.SelectedIndex := 0;
end;

procedure TWinForm.ExitMenuItem_Click(sender: System.Object; e: System.EventArgs);
begin
  Application.Exit;
end;

procedure TWinForm.AboutMenuItem_Click(sender: System.Object; e: System.EventArgs);
begin
  MessageBox.Show(
    FRm.GetString('Converter is an application that converts metric units to US units and back.'),
    FRm.GetString('About Converter'),
    MessageBoxButtons.OK,
    MessageBoxIcon.Information);
end;

procedure TWinForm.TypeCombo_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
begin
  metricCombo.Items.Clear();
  usCombo.Items.Clear();

  case Quantity of
    TQuantity.qaLength:
    begin
      addMetric('Kilometers');
      addMetric('Meters');
      addMetric('Centimeters');
      addMetric('Millimeters');
      addUs('Miles');
      addUs('Yards');
      addUs('Feet');
      addUs('Inches');
    end;

    TQuantity.qaTemperature:
    begin
      addMetric('Celsius');
      addMetric('Kelvin');
      addUs('Fahrenheit');
    end;
  end;

  metricCombo.SelectedIndex := 0;
  usCombo.SelectedIndex := 0;
end;

procedure TWinForm.MetricText_TextChanged(sender: System.Object; e: System.EventArgs);
begin
  if FUpdating or (metricText.Text = '') then
    Exit;

  case Quantity of
    TQuantity.qaLength:
      UsValue := Measurements.metricLengthToUsLength(MetricValue, MetricLength, UsLength);

    TQuantity.qaTemperature:
      UsValue := Measurements.metricTemperatureToUsTemperature(MetricValue, MetricTemperature, UsTemperature);
  end;
end;

procedure TWinForm.UsText_TextChanged(sender: System.Object; e: System.EventArgs);
begin
  if FUpdating or (usText.Text = '') then
    Exit;

  case Quantity of
    TQuantity.qaLength:
      MetricValue := Measurements.usLengthToMetricLength(UsValue, UsLength, MetricLength);

    TQuantity.qaTemperature:
      MetricValue := Measurements.usTemperatureToMetricTemperature(UsValue, UsTemperature, MetricTemperature);
  end;
end;

initialization
  // Set the user interface culture to match th default culture of the system
  Thread.CurrentThread.CurrentUICulture := CultureInfo.CurrentCulture;
end.
