unit WinForm;

interface

uses
  System.Drawing,
  System.Collections,
  System.ComponentModel,
  System.Windows.Forms,
  System.Data,
  LaCommon;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    MainMenu: System.Windows.Forms.MainMenu;
    FileMenuItem: System.Windows.Forms.MenuItem;
    ExitMenuItem: System.Windows.Forms.MenuItem;
    HelpMenuItem: System.Windows.Forms.MenuItem;
    AboutMenuItem: System.Windows.Forms.MenuItem;
    TypeLabel: System.Windows.Forms.Label;
    TypeCombo: System.Windows.Forms.ComboBox;
    MetricUnitLabel: System.Windows.Forms.Label;
    MetricCombo: System.Windows.Forms.ComboBox;
    MetricAmountLabel: System.Windows.Forms.Label;
    MetricText: System.Windows.Forms.TextBox;
    UsUnitLabel: System.Windows.Forms.Label;
    Label5: System.Windows.Forms.Label;
    UsCombo: System.Windows.Forms.ComboBox;
    UsText: System.Windows.Forms.TextBox;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure TWinForm_Load(sender: System.Object; e: System.EventArgs);
    procedure MetricText_TextChanged(sender: System.Object; e: System.EventArgs);
    procedure TypeCombo_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure UsText_TextChanged(sender: System.Object; e: System.EventArgs);
    procedure ExitMenuItem_Click(sender: System.Object; e: System.EventArgs);
    procedure AboutMenuItem_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;

  private
    FUpdating: Boolean;

    function GetQuantity: TQuantity;
    function GetMetricLength: TLaMetricLength;
    function GetUsLength: TLaUsLength;
    function GetMetricTemperature: TLaMetricTemperature;
    function GetUsTemperature: TLaUsTemperature;

    function GetMetricValue: System.Double;
    procedure SetMetricValue(Value: System.Double);

    function GetUsValue: System.Double;
    procedure SetUsValue(Value: System.Double);

    procedure AddMetric(value: String);
    procedure AddUs(value: String);

  public
    constructor Create;

    property Quantity: TQuantity read GetQuantity;
    property MetricLength: TLaMetricLength read GetMetricLength;
    property UsLength: TLaUsLength read GetUsLength;
    property MetricTemperature: TLaMetricTemperature read GetMetricTemperature;
    property UsTemperature: TLaUsTemperature read GetUsTemperature;
    property MetricValue: System.Double read GetMetricValue write SetMetricValue;
    property UsValue: System.Double read GetUsValue write SetUsValue;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
type
  TArrayOfSystem_Windows_Forms_MenuItem = array of System.Windows.Forms.MenuItem;
begin
  Self.MainMenu := System.Windows.Forms.MainMenu.Create;
  Self.FileMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.ExitMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.HelpMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.AboutMenuItem := System.Windows.Forms.MenuItem.Create;
  Self.TypeLabel := System.Windows.Forms.Label.Create;
  Self.TypeCombo := System.Windows.Forms.ComboBox.Create;
  Self.MetricUnitLabel := System.Windows.Forms.Label.Create;
  Self.MetricCombo := System.Windows.Forms.ComboBox.Create;
  Self.MetricAmountLabel := System.Windows.Forms.Label.Create;
  Self.MetricText := System.Windows.Forms.TextBox.Create;
  Self.UsUnitLabel := System.Windows.Forms.Label.Create;
  Self.Label5 := System.Windows.Forms.Label.Create;
  Self.UsCombo := System.Windows.Forms.ComboBox.Create;
  Self.UsText := System.Windows.Forms.TextBox.Create;
  Self.SuspendLayout;
  // 
  // MainMenu
  // 
  Self.MainMenu.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.FileMenuItem, 
          Self.HelpMenuItem));
  // 
  // FileMenuItem
  // 
  Self.FileMenuItem.Index := 0;
  Self.FileMenuItem.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.ExitMenuItem));
  Self.FileMenuItem.Text := '&File';
  // 
  // ExitMenuItem
  // 
  Self.ExitMenuItem.Index := 0;
  Self.ExitMenuItem.Text := '&Exit';
  Include(Self.ExitMenuItem.Click, Self.ExitMenuItem_Click);
  // 
  // HelpMenuItem
  // 
  Self.HelpMenuItem.Index := 1;
  Self.HelpMenuItem.MenuItems.AddRange(TArrayOfSystem_Windows_Forms_MenuItem.Create(Self.AboutMenuItem));
  Self.HelpMenuItem.Text := '&Help';
  // 
  // AboutMenuItem
  // 
  Self.AboutMenuItem.Index := 0;
  Self.AboutMenuItem.Text := '&About...';
  Include(Self.AboutMenuItem.Click, Self.AboutMenuItem_Click);
  // 
  // TypeLabel
  // 
  Self.TypeLabel.AutoSize := True;
  Self.TypeLabel.Location := System.Drawing.Point.Create(8, 8);
  Self.TypeLabel.Name := 'TypeLabel';
  Self.TypeLabel.Size := System.Drawing.Size.Create(33, 16);
  Self.TypeLabel.TabIndex := 0;
  Self.TypeLabel.Text := '&Type:';
  // 
  // TypeCombo
  // 
  Self.TypeCombo.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.TypeCombo.Location := System.Drawing.Point.Create(8, 24);
  Self.TypeCombo.Name := 'TypeCombo';
  Self.TypeCombo.Size := System.Drawing.Size.Create(208, 21);
  Self.TypeCombo.TabIndex := 1;
  Include(Self.TypeCombo.SelectedIndexChanged, Self.TypeCombo_SelectedIndexChanged);
  // 
  // MetricUnitLabel
  // 
  Self.MetricUnitLabel.AutoSize := True;
  Self.MetricUnitLabel.Location := System.Drawing.Point.Create(8, 48);
  Self.MetricUnitLabel.Name := 'MetricUnitLabel';
  Self.MetricUnitLabel.Size := System.Drawing.Size.Create(60, 16);
  Self.MetricUnitLabel.TabIndex := 2;
  Self.MetricUnitLabel.Text := '&Metric unit:';
  // 
  // MetricCombo
  // 
  Self.MetricCombo.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.MetricCombo.Location := System.Drawing.Point.Create(8, 64);
  Self.MetricCombo.Name := 'MetricCombo';
  Self.MetricCombo.Size := System.Drawing.Size.Create(208, 21);
  Self.MetricCombo.TabIndex := 3;
  // 
  // MetricAmountLabel
  // 
  Self.MetricAmountLabel.AutoSize := True;
  Self.MetricAmountLabel.Location := System.Drawing.Point.Create(8, 88);
  Self.MetricAmountLabel.Name := 'MetricAmountLabel';
  Self.MetricAmountLabel.Size := System.Drawing.Size.Create(79, 16);
  Self.MetricAmountLabel.TabIndex := 4;
  Self.MetricAmountLabel.Text := 'Metric &amount:';
  // 
  // MetricText
  // 
  Self.MetricText.Location := System.Drawing.Point.Create(8, 104);
  Self.MetricText.Name := 'MetricText';
  Self.MetricText.Size := System.Drawing.Size.Create(208, 20);
  Self.MetricText.TabIndex := 5;
  Self.MetricText.Text := '';
  Include(Self.MetricText.TextChanged, Self.MetricText_TextChanged);
  // 
  // UsUnitLabel
  // 
  Self.UsUnitLabel.AutoSize := True;
  Self.UsUnitLabel.Location := System.Drawing.Point.Create(8, 128);
  Self.UsUnitLabel.Name := 'UsUnitLabel';
  Self.UsUnitLabel.Size := System.Drawing.Size.Create(44, 16);
  Self.UsUnitLabel.TabIndex := 6;
  Self.UsUnitLabel.Text := '&US unit:';
  // 
  // Label5
  // 
  Self.Label5.AutoSize := True;
  Self.Label5.Location := System.Drawing.Point.Create(8, 168);
  Self.Label5.Name := 'Label5';
  Self.Label5.Size := System.Drawing.Size.Create(64, 16);
  Self.Label5.TabIndex := 7;
  Self.Label5.Text := 'US a&mount:';
  // 
  // UsCombo
  // 
  Self.UsCombo.DropDownStyle := System.Windows.Forms.ComboBoxStyle.DropDownList;
  Self.UsCombo.Location := System.Drawing.Point.Create(8, 144);
  Self.UsCombo.Name := 'UsCombo';
  Self.UsCombo.Size := System.Drawing.Size.Create(208, 21);
  Self.UsCombo.TabIndex := 8;
  // 
  // UsText
  // 
  Self.UsText.Location := System.Drawing.Point.Create(8, 184);
  Self.UsText.Name := 'UsText';
  Self.UsText.Size := System.Drawing.Size.Create(208, 20);
  Self.UsText.TabIndex := 9;
  Self.UsText.Text := '';
  Include(Self.UsText.TextChanged, Self.UsText_TextChanged);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(225, 218);
  Self.Controls.Add(Self.UsText);
  Self.Controls.Add(Self.UsCombo);
  Self.Controls.Add(Self.Label5);
  Self.Controls.Add(Self.UsUnitLabel);
  Self.Controls.Add(Self.MetricText);
  Self.Controls.Add(Self.MetricAmountLabel);
  Self.Controls.Add(Self.MetricCombo);
  Self.Controls.Add(Self.MetricUnitLabel);
  Self.Controls.Add(Self.TypeCombo);
  Self.Controls.Add(Self.TypeLabel);
  Self.Menu := Self.MainMenu;
  Self.Name := 'TWinForm';
  Self.Text := 'Converter';
  Include(Self.Load, Self.TWinForm_Load);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  InitializeComponent;
end;

function TWinForm.GetQuantity: TQuantity;
begin
  Result := TQuantity(TypeCombo.SelectedIndex);
end;

function TWinForm.GetMetricLength: TLaMetricLength;
begin
  Result := TLaMetricLength(MetricCombo.SelectedIndex);
end;

function TWinForm.GetUsLength: TLaUsLength;
begin
  Result := TLaUsLength(UsCombo.SelectedIndex);
end;

function TWinForm.GetMetricTemperature: TLaMetricTemperature;
begin
  Result := TLaMetricTemperature(MetricCombo.SelectedIndex);
end;

function TWinForm.GetUsTemperature: TLaUsTemperature;
begin
  Result := TLaUsTemperature(UsCombo.SelectedIndex);
end;

function TWinForm.GetMetricValue: System.Double;
begin
  try
    Result := Convert.ToDouble(MetricText.Text);
  except
    Result := 0;
  end;
end;

procedure TWinForm.SetMetricValue(Value: System.Double);
begin
  try
    FUpdating := True;
    MetricText.Text := value.ToString('F');
  finally
    FUpdating := False;
  end;
end;

function TWinForm.GetUsValue: System.Double;
begin
  try
    Result := Convert.ToDouble(UsText.Text);
  except
    Result := 0;
  end;
end;

procedure TWinForm.SetUsValue(Value: System.Double);
begin
  try
    FUpdating := True;
    UsText.Text := value.ToString('F');
  finally
    FUpdating := False;
  end;
end;

procedure TWinForm.AddMetric(value: String);
begin
  MetricCombo.Items.Add(value);
end;

procedure TWinForm.AddUs(value: String);
begin
  UsCombo.Items.Add(value);
end;

procedure TWinForm.TWinForm_Load(sender: System.Object; e: System.EventArgs);
begin
  TypeCombo.Items.Add('Length');
  TypeCombo.Items.Add('Temperature');
  TypeCombo.SelectedIndex := 0;
end;

procedure TWinForm.ExitMenuItem_Click(sender: System.Object; e: System.EventArgs);
begin
  Application.Exit;
end;

procedure TWinForm.AboutMenuItem_Click(sender: System.Object; e: System.EventArgs);
begin
  MessageBox.Show(
    'Converter is an application that converts metric units to US units and back.',
    'About Converter',
    MessageBoxButtons.OK,
    MessageBoxIcon.Information);
end;

procedure TWinForm.TypeCombo_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
begin
  metricCombo.Items.Clear();
  usCombo.Items.Clear();

  case Quantity of
    TQuantity.qaLength:
    begin
      addMetric('Kilometers');
      addMetric('Meters');
      addMetric('Centimeters');
      addMetric('Millimeters');
      addUs('Miles');
      addUs('Yards');
      addUs('Feet');
      addUs('Inches');
    end;

    TQuantity.qaTemperature:
    begin
      addMetric('Celsius');
      addMetric('Kelvin');
      addUs('Farenheit');
    end;
  end;

  metricCombo.SelectedIndex := 0;
  usCombo.SelectedIndex := 0;
end;

procedure TWinForm.MetricText_TextChanged(sender: System.Object; e: System.EventArgs);
begin
  if FUpdating or (metricText.Text = '') then
    Exit;

  case Quantity of
    TQuantity.qaLength:
      UsValue := Measurements.metricLengthToUsLength(MetricValue, MetricLength, UsLength);

    TQuantity.qaTemperature:
      UsValue := Measurements.metricTemperatureToUsTemperature(MetricValue, MetricTemperature, UsTemperature);
  end;
end;

procedure TWinForm.UsText_TextChanged(sender: System.Object; e: System.EventArgs);
begin
  if FUpdating or (usText.Text = '') then
    Exit;

  case Quantity of
    TQuantity.qaLength:
      MetricValue := Measurements.usLengthToMetricLength(UsValue, UsLength, MetricLength);

    TQuantity.qaTemperature:
      MetricValue := Measurements.usTemperatureToMetricTemperature(UsValue, UsTemperature, MetricTemperature);
  end;
end;

end.
