#ifndef MEASUREMENT_H
#define MEASUREMENT_H

enum MeasurementSystem
{
  Metric,
  US
};

enum Quantity
{
  Length,
  Temperature
};

enum MetricLength
{
  Km,
  m,
  cm,
  mm
};

enum UsLength
{
  Mile,
  Yard,
  Foot,
  Inch
};

enum MetricTemperature
{
  Celsius,
  Kelvin
};

enum UsTemperature
{
  Fahrenheit
};

static const double MILE_AS_METERS = 1609.3;
static const double YARD_AS_METERS = 0.9144;

static const int INCH_IN_FEET = 12;
static const int FEET_IN_YARD = 3;
static const int YARDS_IN_MILE = 1760;

static const double CELSIUS_OFFSET = 273.15;
static const double FAHRENHEIT_OFFSET = 32;
static const double FAHRENHEIT_FACTOR = 1.8;

double metricLengthToUsLength(double value, MetricLength metricLength, UsLength usLength);
double usLengthToMetricLength(double value, UsLength usLength, MetricLength metricLength);

double metricTemperatureToUsTemperature(double value, MetricTemperature metricTemperature, UsTemperature usTemperature);
double usTemperatureToMetricTemperature(double value, UsTemperature usTemperature, MetricTemperature metricTemperature);

#endif // MEASUREMENT_H
