#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include "measurement.h"
#include "ui_mainwindow.h"

class MainWindow : public QMainWindow
{
    Q_OBJECT

  private:
    bool updating;
    Quantity getQuantity();
    MetricLength getMetricLength();
    UsLength getUsLength();
    MetricTemperature getMetricTemperature();
    UsTemperature getUsTemperature();

    double getMetricValue();
    double getUsValue();

    void setMetricValue(double value);
    void setUsValue(double value);

  public slots:
    void typeChanged(int index);
    void metricUnitChanged(int index);
    void metricAmountChanged();
    void usUnitChanged(int index);
    void usAmountChanged();
    void about();

  public:
    MainWindow(QWidget *parent = 0, Qt::WFlags flags = 0);
    ~MainWindow();

  private:
    Ui::MainWindowClass ui;
};

#endif // MAINWINDOW_H
