{
  This sample shows you how to control the source code localization using
  the slz and noslz tags.

  Read more about source code localization from online help from "Source code localization" topic
}

program PascalSample;
var
  str: String;
begin
  // This s a basic string. Sisulizer extracts it and localizes it.
  str := 'Hello World';

  // Whenever a line contains noslz comment Sisulizer does not localize string(s) on that line
  str := 'SELECT * FROM Sample'; //noslz

  // You can attach a comment to the string by using slz tag followed by the comment string
  str := 'This string has a comment'; //slz This is a sample comment

  // You can give the maximing string length in characters using the MaxChars attribute in the slz comment
  str := 'One'; //slz MaxChars=10

  // You can give the maximing string length in pixels using the MaxPixels attribute in the slz comment
  str := 'Two'; //slz MaxPixels=100

  // You can break combined string into pieces by giving the breaking expression in the Expression attribute
  str := '"\One;Two;Three'; //slz Expression="\"\\\\#;#;#"

  // Sisulizer automatically combines following strings into one single string
  str := 'One' + 'Two' + 'Three';
  str := 'One'#13#10'Two'#9'Three';
end.
