﻿/* This script creates and populates the Translation table in Oracle */
CREATE TABLE Translations
(
  English NVARCHAR2(200) NOT NULL,
  Finnish NVARCHAR2(200) NOT NULL,
  German NVARCHAR2(200) NOT NULL,
  Japanese NVARCHAR2(200) NOT NULL,
  CommentValue NVARCHAR2(200) NOT NULL,
  PRIMARY KEY(English)
);

/* Populates the table. Japanese strings are encoded in Japanese code page so they look weird */
INSERT INTO Translations VALUES('United States', 'Yhdysvallat', 'Vereinigte Staaten', 'ƒAƒƒŠƒJ‡O‘', 'Name of country');
INSERT INTO Translations VALUES('Washington, D.C.', 'Washington, D.C.', 'Washington, D.C.', 'ƒƒVƒ“ƒgƒ“DC', 'Capital of USA');
INSERT INTO Translations VALUES('The United States of America is a federal republic of 50 states, located primary on central North America.', 'Amerikan yhdysvallat on 50 osavaltion liittovaltio, joka sijaitsee suurelta osin pohjois-amerikassa.', 'Die Vereinigten Staaten von Amerika sind ein Zusammenschluss von 50 Staaten hauptsächlich auf dem Nordamerikanischen Zentralkontinent.', 'ƒAƒƒŠƒJ‡O‘‚Í50‚ÌB‚©‚ç‚È‚é˜A–M‹¤˜a‘‚Å‚ ‚èAŽå‚Æ‚µ‚Ä–kƒAƒƒŠƒJ‚Ì’†‰›•”‚ÉˆÊ’u‚µ‚Ä‚¢‚Ü‚·B', 'Short description of USA');
INSERT INTO Translations VALUES('Germany', 'Saksa', 'Deutschland', 'ƒhƒCƒc', 'Name of country');
INSERT INTO Translations VALUES('Berlin', 'Berliini', 'Berlin', 'ƒxƒ‹ƒŠƒ“', 'Captital of Germany');
INSERT INTO Translations VALUES('Germany or the Federal Republic of Germany is one of the world''s leading industrialized countries, located in the heart of Europe.', 'Saksa tai Saksan liittotasavalta on yksi maailman johtavista teollisuusmaista Euroopan sydämmessä.', 'Die Bundesrepublik Deutschland ist eine der führenden Industrienationen im Herz von Europa.', 'ƒhƒCƒcA‚Ü‚½‚ÍƒhƒCƒc˜A–M‹¤˜a‘‚Í¢ŠE‚ÌŽå—v‚ÈH‹Æ‘‚Ìˆê‚Â‚Å‚ ‚èAƒˆ[ƒƒbƒp‚Ì’†S‚ÉˆÊ’u‚µ‚Ä‚¢‚Ü‚·B', 'Short description of Germany');
INSERT INTO Translations VALUES('Japan', 'Japani', 'Japan', '“ú–{', 'Name of country');
INSERT INTO Translations VALUES('Tokyo', 'Tokio', 'Tokio', '“Œ‹ž', 'Capital of Japan');
INSERT INTO Translations VALUES('Japan is a country on the western edge of the Pacific Ocean.', 'Japani on maa tyynen valtameren länsipuolella.', 'Japan ist ein Land am westlichen Rand des Pazifischen Ozean.', '“ú–{‚Í‘¾•½—m‚Ì¼’[‚ÉˆÊ’u‚·‚é‘‚Å‚·B', 'Short description of Japan');
