/* This script creates and populates the Translation table in PostgreSQL */
/* Use this if your database uses SQL_ASCII encoding */
CREATE TABLE Translations
(
  English VARCHAR(200) NOT NULL,
  Finnish VARCHAR(200) NOT NULL,
  German VARCHAR(200) NOT NULL,
  Japanese VARCHAR(200) NOT NULL,
  Comment VARCHAR(200) NOT NULL,
  PRIMARY KEY(English)
);

/* Populates the table. Japanese strings are encoded in Japanese code page so they look weird */
INSERT INTO Translations VALUES('United States', 'Yhdysvallat', 'Vereinigte Staaten', 'AJO', 'Name of country');
INSERT INTO Translations VALUES('Washington, D.C.', 'Washington, D.C.', 'Washington, D.C.', 'VgDC', 'Capital of USA');
INSERT INTO Translations VALUES('The United States of America is a federal republic of 50 states, located primary on central North America.', 'Amerikan yhdysvallat on 50 osavaltion liittovaltio, joka sijaitsee suurelta osin pohjois-amerikassa.', 'Die Vereinigten Staaten von Amerika sind ein Zusammenschluss von 50 Staaten hauptschlich auf dem Nordamerikanischen Zentralkontinent.', 'AJO50̏BȂAMałAƂĖkAJ̒ɈʒuĂ܂B', 'Short description of USA');
INSERT INTO Translations VALUES('Germany', 'Saksa', 'Deutschland', 'hCc', 'Name of country');
INSERT INTO Translations VALUES('Berlin', 'Berliini', 'Berlin', 'x', 'Captital of Germany');
INSERT INTO Translations VALUES('Germany or the Federal Republic of Germany is one of the world''s leading industrialized countries, located in the heart of Europe.', 'Saksa tai Saksan liittotasavalta on yksi maailman johtavista teollisuusmaista Euroopan sydmmess.', 'Die Bundesrepublik Deutschland ist eine der fhrenden Industrienationen im Herz von Europa.', 'hCcA܂̓hCcAMa͐E̎vȍHƍ̈łA[bp̒SɈʒuĂ܂B', 'Short description of Germany');
INSERT INTO Translations VALUES('Japan', 'Japani', 'Japan', '{', 'Name of country');
INSERT INTO Translations VALUES('Tokyo', 'Tokio', 'Tokio', '', 'Capital of Japan');
INSERT INTO Translations VALUES('Japan is a country on the western edge of the Pacific Ocean.', 'Japani on maa tyynen valtameren lnsipuolella.', 'Japan ist ein Land am westlichen Rand des Pazifischen Ozean.', '{͑m̐[Ɉʒu鍑łB', 'Short description of Japan');
