﻿/* This script creates and populates the Translation table in PostgreSQL */
/* Use this if your database uses UTF-8 encoding */
CREATE TABLE Translations
(
  English VARCHAR(200) NOT NULL,
  Finnish VARCHAR(200) NOT NULL,
  German VARCHAR(200) NOT NULL,
  Japanese VARCHAR(200) NOT NULL,
  Comment VARCHAR(200) NOT NULL,
  PRIMARY KEY(English)
);

/* Populates the table. Japanese strings are encoded in Japanese code page so they look weird */
INSERT INTO Translations VALUES('United States', 'Yhdysvallat', 'Vereinigte Staaten', 'アメリカ合衆国', 'Name of country');
INSERT INTO Translations VALUES('Washington, D.C.', 'Washington, D.C.', 'Washington, D.C.', 'ワシントンDC', 'Capital of USA');
INSERT INTO Translations VALUES('The United States of America is a federal republic of 50 states, located primary on central North America.', 'Amerikan yhdysvallat on 50 osavaltion liittovaltio, joka sijaitsee suurelta osin pohjois-amerikassa.', 'Die Vereinigten Staaten von Amerika sind ein Zusammenschluss von 50 Staaten hauptsächlich auf dem Nordamerikanischen Zentralkontinent.', 'アメリカ合衆国は50の州からなる連邦共和国であり、主として北アメリカの中央部に位置しています。', 'Short description of USA');
INSERT INTO Translations VALUES('Germany', 'Saksa', 'Deutschland', 'ドイツ', 'Name of country');
INSERT INTO Translations VALUES('Berlin', 'Berliini', 'Berlin', 'ベルリン', 'Captital of Germany');
INSERT INTO Translations VALUES('Germany or the Federal Republic of Germany is one of the world''s leading industrialized countries, located in the heart of Europe.', 'Saksa tai Saksan liittotasavalta on yksi maailman johtavista teollisuusmaista Euroopan sydämmessä.', 'Die Bundesrepublik Deutschland ist eine der führenden Industrienationen im Herz von Europa.', 'ドイツ、またはドイツ連邦共和国は世界の主要な工業国の一つであり、ヨーロッパの中心に位置しています。', 'Short description of Germany');
INSERT INTO Translations VALUES('Japan', 'Japani', 'Japan', '日本', 'Name of country');
INSERT INTO Translations VALUES('Tokyo', 'Tokio', 'Tokio', '東京', 'Capital of Japan');
INSERT INTO Translations VALUES('Japan is a country on the western edge of the Pacific Ocean.', 'Japani on maa tyynen valtameren länsipuolella.', 'Japan ist ein Land am westlichen Rand des Pazifischen Ozean.', '日本は太平洋の西端に位置する国です。', 'Short description of Japan');
