VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Converter"
   ClientHeight    =   3180
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   3150
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3180
   ScaleWidth      =   3150
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox UsText 
      Height          =   285
      Left            =   120
      TabIndex        =   9
      Top             =   2760
      Width           =   2895
   End
   Begin VB.TextBox MetricText 
      Height          =   285
      Left            =   120
      TabIndex        =   6
      Top             =   1560
      Width           =   2895
   End
   Begin VB.ComboBox UsCombo 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   2160
      Width           =   2895
   End
   Begin VB.ComboBox MetricCombo 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   960
      Width           =   2895
   End
   Begin VB.ComboBox TypeCombo 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   360
      Width           =   2895
   End
   Begin VB.Label UsAmountLabel 
      AutoSize        =   -1  'True
      Caption         =   "US a&mount:"
      Height          =   195
      Left            =   120
      TabIndex        =   8
      Top             =   2520
      Width           =   840
   End
   Begin VB.Label UsUnitLabel 
      AutoSize        =   -1  'True
      Caption         =   "&US unit:"
      Height          =   195
      Left            =   120
      TabIndex        =   7
      Top             =   1920
      Width           =   570
   End
   Begin VB.Label MetricAmountLabel 
      AutoSize        =   -1  'True
      Caption         =   "Metric &amount:"
      Height          =   195
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   1050
   End
   Begin VB.Label MetricUnitLabel 
      AutoSize        =   -1  'True
      Caption         =   "&Metric unit:"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   780
   End
   Begin VB.Label TypeLabel 
      AutoSize        =   -1  'True
      Caption         =   "&Type:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   405
   End
   Begin VB.Menu FileMenu 
      Caption         =   "&File"
      Begin VB.Menu ExitMenu 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu HelpMenu 
      Caption         =   "&Help"
      Begin VB.Menu AboutMenu 
         Caption         =   "&About..."
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Updating As Boolean

Private Sub AddMetric(value As String)
  MetricCombo.AddItem (value)
End Sub

Private Sub AddUs(value As String)
  UsCombo.AddItem (value)
End Sub

Private Sub AboutMenu_Click()
  MsgBox "Converter is an application that converts metric units to US units and back.", vbOKOnly, "About Converter"
End Sub

Private Sub ExitMenu_Click()
  Unload Me
End Sub

Private Sub Form_Load()
  FUpdating = False
  
  TypeCombo.AddItem ("Length")
  TypeCombo.AddItem ("Temperature")
  TypeCombo.ListIndex = 0
  TypeCombo_Click
End Sub

Private Sub MetricCombo_Click()
  MetricText_Change
End Sub

Private Sub MetricText_Change()
  Dim usValue As Double
  Dim metricValue As Double
  
  If Updating Or (MetricText.Text = "") Then
    Exit Sub
  End If
  
  metricValue = Val(MetricText.Text)
  
  Select Case TypeCombo.ListIndex
    Case qaLength
      usValue = MetricLengthToUsLength(metricValue, MetricCombo.ListIndex, UsCombo.ListIndex)

    Case qaTemperature
      usValue = MetricTemperatureToUsTemperature(metricValue, MetricCombo.ListIndex, UsCombo.ListIndex)
  End Select
  
  Updating = True
  UsText.Text = FormatNumber(usValue, 2)
  Updating = False
End Sub

Private Sub TypeCombo_Click()
  MetricCombo.Clear
  UsCombo.Clear
  
  Select Case TypeCombo.ListIndex
    Case 0
      AddMetric ("Kilometers")
      AddMetric ("Meters")
      AddMetric ("Centimeters")
      AddMetric ("Millimeters")
      
      AddUs ("Miles")
      AddUs ("Yards")
      AddUs ("Feet")
      AddUs ("Inches")
      
    Case 1
      AddMetric ("Celsius")
      AddMetric ("Kelvin")
      
      AddUs ("Fahrenheit")
  End Select
  
  MetricCombo.ListIndex = 0
  UsCombo.ListIndex = 0
End Sub

Private Sub UsCombo_Click()
  UsText_Change
End Sub

Private Sub UsText_Change()
  Dim metricValue As Double
  Dim usValue As Double
  
  If Updating Or (UsText.Text = "") Then
    Exit Sub
  End If
  
  usValue = Val(UsText.Text)

  Select Case TypeCombo.ListIndex
    Case qaLength
      metricValue = UsLengthToMetricLength(usValue, UsCombo.ListIndex, MetricCombo.ListIndex)

    Case qaTemperature
      metricValue = UsTemperatureToMetricTemperature(usValue, UsCombo.ListIndex, MetricCombo.ListIndex)
  End Select
  
  Updating = True
  MetricText.Text = FormatNumber(metricValue, 2)
  Updating = False
End Sub
