{
  This applications shows how to load custom resources from the active resource
  DLL.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    procedure Initialize;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Jpeg,
  LaDialog,
  LaResource,
  LaTranslator;

procedure TForm1.Initialize;
resourcestring
  SMsg = 'Powder skiing';
var
  image: TJpegImage;
  stream: TResourceStream;
begin
  // Do not use HInstance but LaResource.GetResourceInstance because HInstance
  // always loads from the main EXE. GetResourceInstance returns instance of
  // resource DLL if it has been loaded.
  stream := TResourceStream.Create(GetResourceInstance, 'Sample', 'IMAGE');
  image := TJpegImage.Create;
  try
    image.LoadFromStream(stream);
    Image1.Picture.Graphic := image;
  finally
    image.Free;
    stream.Free;
  end;

  Label1.Caption := SMsg;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Initialize;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if LaDialog.SelectResourceLocale('EN') then
    Initialize;
end;

initialization
  // Translate only string properties when performing runtime language switch
  LaEnabledProperties := STRING_TYPES_C;
end.
