unit MyControl;

interface

uses
  Classes,
  ExtCtrls;

type
  TMyCategory = (mcNormal, mcHighPriority, mcFast);

  TMyControl = class(TPanel)
  private
    FCategory: TMyCategory;
    FDescription: String;
    FLimitInt: Integer;
    FLimitFloat: Double;
    FSyntax: String;

    procedure SetDescription(const value: String);

  protected
    procedure Paint; override;

  public
    constructor Create(owner: TComponent); override;

  published
    property Category: TMyCategory read FCategory write FCategory stored True;
    property Description: String read FDescription write SetDescription;
    property LimitInt: Integer read FLimitInt write FLimitInt stored True;
    property LimitFloat: Double read FLimitFloat write FLimitFloat stored True;
    property Syntax: String read FSyntax write FSyntax;
  end;

  procedure Register;

implementation

uses
  Windows,
  Graphics;

constructor TMyControl.Create(owner: TComponent);
begin
  inherited;
  FCategory := mcNormal;
  FLimitInt := 1;
  FLimitFloat := 1.5;
end;

procedure TMyControl.SetDescription(const value: String);
begin
  if value <> FDescription then
  begin
    FDescription := value;
    Invalidate;
  end;
end;

procedure TMyControl.Paint;
var
  rect: TRect;
  fontHeight: Integer;
begin
  inherited;

  rect := GetClientRect;

  with Canvas do
  begin
    Brush.Style := bsClear;
    Font := Self.Font;
    fontHeight := TextHeight('W');

    with rect do
    begin
      Top := ((Bottom + Top) - fontHeight) div 2 + 2*fontHeight;
      Bottom := Top + fontHeight;
    end;

    DrawText(Handle, PChar(Description), -1, rect, DT_EXPANDTABS or DT_VCENTER or DT_CENTER);
  end;
end;

procedure Register;
begin
  RegisterComponents('Sisulizer', [TMyControl]);
end;

end.
