{
  Copyrights 2005-2007 Sisulizer Oy

  This sample application shows how to create a multilingual Ace Reporter
  application.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SctVar, ExtCtrls, SctRep, DB, DBTables, StdCtrls, SctCtrl, AcePage;

type
  TForm1 = class(TForm)
    Report: TSctReport;
    ReportPage: TSctGrouppage;
    ReportHeaderBand: TSctBand;
    ReportHeaderBandlevel: TSctLevel;
    PageHeaderBand: TSctBand;
    PageHeaderBandlevel: TSctLevel;
    DetailBand: TSctBand;
    DetailBandlevel: TSctLevel;
    PageFooterBand: TSctBand;
    PageFooterBandlevel: TSctLevel;
    ReportFooterBand: TSctBand;
    ReportFooterBandlevel: TSctLevel;
    PreviewButton: TButton;
    LanguageButton: TButton;
    CountryQuery: TQuery;
    svarDateTime: TSctDateTimeVar;
    svarPage: TSctPageVar;
    DataSource: TDataSource;
    DataSourceGuide: TSctDataSourceGuide;
    countryqueryIdVar: TSctDBVar;
    countryqueryLanguageVar: TSctDBVar;
    countryqueryNameVar: TSctDBVar;
    countryqueryPopulationVar: TSctDBVar;
    countryqueryCapitalVar: TSctDBVar;
    countryqueryDescriptionVar: TSctDBVar;
    varlabel: TSctvarlabel;
    varlabel1: TSctvarlabel;
    varlabel2: TSctvarlabel;
    varlabel3: TSctvarlabel;
    Sctvarlabel1: TSctvarlabel;
    Sctvarlabel2: TSctvarlabel;
    Sctvarlabel3: TSctvarlabel;
    Sctvarlabel4: TSctvarlabel;
    procedure LanguageButtonClick(Sender: TObject);
    procedure PreviewButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    function GetLanguage: String;

    procedure Initialize;

  public
    property Language: String read GetLanguage;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  LaDialog,
  LaResource;

function TForm1.GetLanguage: String;
begin
  // Returns the active language code
  Result := LowerCase(GetActiveResourceLocale('EN'));
end;

procedure TForm1.Initialize;
begin
  if CountryQuery.Active then
    CountryQuery.Close;

  // Set query that shows database rows that use the selected language
  CountryQuery.SQL.Text := Format('SELECT * FROM Country WHERE Language=''%s''', [Language]);
  CountryQuery.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Initialize;
end;

procedure TForm1.PreviewButtonClick(Sender: TObject);
begin
  Report.Run;
end;

procedure TForm1.LanguageButtonClick(Sender: TObject);
begin
  // Perform runtime language change
  CheckResourceCount;

  if SelectResourceLocale('EN') then
    Initialize;
end;

end.
