{
  Copyrights 2005-2007 Sisulizer Oy

  This sample application shows how to create a multilingual QuickReport
  application.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DB, DBTables, QuickRpt, QRCtrls;

type
  TForm1 = class(TForm)
    PreviewButton: TButton;
    LanguageButton: TButton;
    CountryQuery: TQuery;
    QuickRep: TQuickRep;
    HeaderBand: TQRBand;
    NameLabel: TQRLabel;
    CapitalLabel: TQRLabel;
    DescriptionLabel: TQRLabel;
    PopulationLabel: TQRLabel;
    DetailBand: TQRBand;
    NameText: TQRDBText;
    CapitalText: TQRDBText;
    DescriptionText: TQRDBText;
    PopulationText: TQRDBText;
    procedure FormCreate(Sender: TObject);
    procedure PreviewButtonClick(Sender: TObject);
    procedure LanguageButtonClick(Sender: TObject);

  private
    function GetLanguage: String;

    procedure Initialize;

  public
    property Language: String read GetLanguage;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  LaDialog,
  LaResource;

function TForm1.GetLanguage: String;
begin
  // Returns the active language code
  Result := LowerCase(GetActiveResourceLocale('EN'));
end;

procedure TForm1.Initialize;
begin
  if CountryQuery.Active then
    CountryQuery.Close;

  // Set query that shows database rows that use the selected language
  CountryQuery.SQL.Text := Format('SELECT * FROM Country WHERE Language=''%s''', [Language]);
  CountryQuery.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Initialize;
end;

procedure TForm1.PreviewButtonClick(Sender: TObject);
begin
  QuickRep.Preview;
end;

procedure TForm1.LanguageButtonClick(Sender: TObject);
begin
  // Perform runtime language change
  CheckResourceCount;

  if SelectResourceLocale('EN') then
    Initialize;
end;

end.
