{
  Copyrights 2005-2011 Sisulizer

  Unit that contains database internationalization routines.
  This compiles with Delphi 5 and later
}

{$I LaDef.inc}

unit LaDbUtils;

interface

uses
  Db;

procedure SetFieldDisplayLabel(dataSet: TDataSet; const fieldName, value: String);
procedure HideField(dataSet: TDataSet; const fieldName: String);

implementation

uses
  SysUtils, LaCommon, LaResource;

procedure SetFieldDisplayLabel(dataSet: TDataSet; const fieldName, value: String);
begin
  if dataSet.Active then
    dataSet.FindField(fieldName).DisplayLabel := value;
end;

procedure HideField(dataSet: TDataSet; const fieldName: String);
var
  i: Integer;
  field: TField;
begin
  for i := 0 to dataSet.FieldCount - 1 do
  begin
    field := dataSet.Fields[i];

    if CompareText(fieldName, field.FieldName) = 0 then
    begin
      field.Visible := False;
      Exit;
    end;
  end;
end;

end.
