{
  Copyrights 2005-2011 Sisulizer

  Unit that translates TNT controls.
  This compiles with Delphi 5 and later

  Note! This unit is provided as it is and not re-developped or supported any more.
}

{$I LaDef.inc}

unit LaTntModule;

interface

uses
  Classes,
  LaTranslator;

type
  TLaTntModule = class(TLaModule)
  public
    function CanTranslate(obj: TObject): Boolean; override;

    procedure Translate(
      component: TComponent;
      obj: TObject;
      const name: String;
      value: Variant;
      index: Integer); override;
  end;

implementation

uses
  Controls,
  TntClasses;

function TLaTntModule.CanTranslate(obj: TObject): Boolean;
begin
  Result := obj is TTntStrings;
end;

procedure TLaTntModule.Translate(
  component: TComponent;
  obj: TObject;
  const name: String;
  value: Variant;
  index: Integer);
var
  oldItemIndex: Integer;
  strings: TTntStrings;
begin
  strings := obj as TTntStrings;

  if (index >= strings.Count) or IgnoreProperty(component, obj, strings[index], value) then
    Exit;

  if component is TCustomListControl then
    oldItemIndex := TCustomListControl(component).ItemIndex
  else
    oldItemIndex := -1;

  strings[index] := value;

  if component is TCustomListControl then
    TCustomListControl(component).ItemIndex := oldItemIndex;

  AfterTranslate(component, obj);
end;

initialization
  LaModules.Register(TLaTntModule);
end.
